package cn.rankin.apiweb.controller;

import cn.rankin.apiweb.assist.resolver.NeedUser;
import cn.rankin.apiweb.code.ApiWebCode;
import cn.rankin.apiweb.service.product.ProductService;
import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.data.api.app.vo.DeviceUserVo;
import cn.rankin.data.api.app.vo.RecommendVo;
import cn.rankin.data.api.product.entity.Poster;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

@RestController
@RequestMapping(value = "/recommend")
public class RecommendController {

    @Autowired
    private ProductService productService;

    @RequestMapping(value = "/courses", method = RequestMethod.GET)
    public APIResult<List<RecommendVo>> getRecommend(@NeedUser DeviceUserVo user) {
        if (user == null) {
            return APIResult.error(ApiWebCode.NOT_EXISTS);
        }

        String merchantId = user.getMerchantId();
        return productService.getRecommendCourses(merchantId);
    }

    /**
     * Get recommend posters
      * @param user
     * @return
     */
    @RequestMapping(value = "/posters", method = RequestMethod.GET)
    public APIResult<Object> getPosters(@NeedUser DeviceUserVo user) {
        if (user == null) {
            return APIResult.error(ApiWebCode.NOT_EXISTS);
        }

        String merchantId = user.getMerchantId();

        //productService.getRecommendCourses(merchantId);

        List<Poster> posters = productService.getPosters(merchantId);
        if (null == posters){
            posters = new ArrayList<>();
        }

        HashMap<String, Object> data = new HashMap<String, Object>();
        data.put("num", posters.size());
        data.put("recs",posters);

        return APIResult.ok(data);
    }
}
